broj_pacijenata = int(input())

krvnih_jedinica = input().split(" ")
jedinica_o = int(krvnih_jedinica[0])
jedinica_a = int(krvnih_jedinica[1])
jedinica_b = int(krvnih_jedinica[2])
jedinica_ab = int(krvnih_jedinica[3])

pacijenti_lista = []
for i in range(broj_pacijenata):
    pacijenti_lista.append((str(input(""))).split(" "))
    pacijenti_lista[i].append(str(i))
gotovi_pacijenti = []

lista_obrada = [[], [], [], []]


def sve_grupe(krvna_grupa, potrebnih_jedinica, indeks):
    global jedinica_o, jedinica_a, jedinica_b, jedinica_ab, gotovi_pacijenti
    potrebnih_jedinica = int(potrebnih_jedinica)
    datih_ab = 0
    datih_a = 0
    datih_b = 0
    datih_o = 0
    if krvna_grupa == "AB":
        while potrebnih_jedinica > 0 and jedinica_ab > 0:
            jedinica_ab -= 1
            datih_ab += 1
            potrebnih_jedinica -= 1
    if krvna_grupa == "AB" or krvna_grupa == "B":
        while potrebnih_jedinica > 0 and jedinica_b > 0:
            jedinica_b -= 1
            datih_b += 1
            potrebnih_jedinica -= 1
    if krvna_grupa == "AB" or krvna_grupa == "A":
        while potrebnih_jedinica > 0 and jedinica_a > 0:
            jedinica_a -= 1
            datih_a += 1
            potrebnih_jedinica -= 1
    if potrebnih_jedinica > 0:
        jedinica_o -= potrebnih_jedinica
        datih_o = potrebnih_jedinica
    gotovi_pacijenti.append([[datih_o, datih_a, datih_b, datih_ab], indeks])


for i in range(len(pacijenti_lista)):
    if pacijenti_lista[i][0] == "O":
        lista_obrada[0].append(pacijenti_lista[i])
    elif pacijenti_lista[i][0] == "A":
        lista_obrada[1].append(pacijenti_lista[i])
    elif pacijenti_lista[i][0] == "B":
        lista_obrada[2].append(pacijenti_lista[i])
    elif pacijenti_lista[i][0] == "AB":
        lista_obrada[3].append(pacijenti_lista[i])

for i in range(len(lista_obrada[0])):
    sve_grupe("O", lista_obrada[0][0][1], lista_obrada[0][0][2])
for i in range(len(lista_obrada[1])):
    sve_grupe("A", lista_obrada[1][0][1], lista_obrada[1][0][2])
for i in range(len(lista_obrada[2])):
    sve_grupe("B", lista_obrada[2][0][1], lista_obrada[2][0][2])
for i in range(len(lista_obrada[3])):
    sve_grupe("AB", lista_obrada[3][0][1], lista_obrada[3][0][2])
konacna_lista = []
for i in range(len(gotovi_pacijenti)):
    konacna_lista.insert(int(gotovi_pacijenti[i][1]), gotovi_pacijenti[i][0])

if jedinica_o < 0 or jedinica_a < 0 or jedinica_b < 0 or jedinica_ab < 0:
    print("nemoguce")
else:
    print("moguce")
    for i in range(len(gotovi_pacijenti)):
        print(str(konacna_lista[i]).strip("[").strip("]").replace(",", ""))